//============================================================================//
//
//  Software Name : MEGADOCK
//
//  Class Name : CPUTime
//
//  Contact address : Tokyo Institute of Technology, AKIYAMA Lab.
//
//============================================================================//

#ifndef Cpu_time_h
#define Cpu_time_h 1

#include <string>
#include <iostream>
#include <stdio.h>

using namespace std;

class CPUTime
{
private:
    friend class Control;
    friend class Docking;
    friend class FFTProcess;
    CPUTime(CPUTime &c) {}
    const CPUTime & operator=(const CPUTime &c);

    float         control_initialize;
    float         receptor_process;
    float         docking_total;
    float         ligand_voxelization;
    float         fftprocess_ligand_fft;
    float         fftprocess_fft_inverse;
    float         fftprocess_score_sort;
    float         fftprocess_sort_index;
    float         docking_output_detail;
    float         docking_output;

public:
    CPUTime() {
    }
    virtual   ~CPUTime()      {
    }
    virtual void      initialize();
    virtual void      output();
};

#endif
